SystemOrganization addCategory: #GODAcademics!

Object subclass: #AcadAcademics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODAcademics'!

!AcadAcademics methodsFor: 'web-interaction' stamp: 'rmc 10/5/2014 11:39'!
acadIndexPage
	"we generate our form and ask the web to exhibe it?
	 We still don't know how this is going to work exactly"
	
	"here we generate our form"

	"here we ask to the web to display it"
	"WebGenarator new generateAcadIndexPage"
	^self notYetImplemented.! !

!AcadAcademics methodsFor: 'web-interaction' stamp: 'rmc 10/5/2014 12:06'!
submitForm: aGoogleScholarProfileLink
	"Main message that will start the whole process sheet"
	"|webPage htmlPageAsString researcher papers journalName|
	webPage := WebPageFetcher new getInformation: aGoogleScholarLink.
	htmlPageAsString := webPage getPage.
	researcher := AcadResearcher new: htmlPageAsString. researcher will put itself together
	
	papers := researcher getListOfPapers.
	sheet := SSSheet new.
	adds cell on the sheet for each impactFactor type (this list will be hardcoded)

	for each paper, get the journalName, assemble a POST object and tell 
	the web to get the page. create an AcadAttribute with name 
	journal and the respective regex, passing the html as parameter. add the new
	atribute to the grid and update the sheet.

	create a PNG image passing the sheet as parameter, and adds the image to the grid
	of the researcher

	generate the final page passing the researcher as parameter."
	^self notYetImplemented
	! !

GODData subclass: #AcadAttribute
	instanceVariableNames: 'value regex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODAcademics'!

!AcadAttribute methodsFor: 'accessing' stamp: 'rmc 10/5/2014 14:07'!
getValue
	"returns the value of this attribute"

	^value.! !

!AcadAttribute methodsFor: 'initialize' stamp: 'rmc 10/5/2014 13:46'!
withPage: aHtmlPage Regex: aRegex
	"this method will create an AcadAtribute with regex := aRegex
	 it will find the value applying a filter to the page using the regex"

	^self notYetImplmented.
! !

GODData subclass: #AcadPaper
	instanceVariableNames: 'coauthors journal numberOfCitations year impactFactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODAcademics'!

!AcadPaper methodsFor: 'accessing' stamp: 'rmc 10/5/2014 14:15'!
getCoauthors
	"returns a collection of attributes"

		^coauthors getValue.! !

!AcadPaper methodsFor: 'accessing' stamp: 'rmc 10/5/2014 14:15'!
getJournal
	"returns the journal that published this paper"

	^journal getValue.! !

!AcadPaper methodsFor: 'accessing' stamp: 'rmc 10/5/2014 14:15'!
getNumberOfCitations
	"returns the the number of citations"

	^numberOfCitations getValue.! !

!AcadPaper methodsFor: 'accessing' stamp: 'rmc 10/5/2014 14:16'!
getYear
	"returns the AcadAttribute corresponding to the year"

	^year getValue.! !

!AcadPaper methodsFor: 'initialize' stamp: 'rmc 10/5/2014 13:53'!
new: aHtmlPaper
	"comment stating purpose of message"

	^ super new.! !

!AcadPaper methodsFor: 'accessing' stamp: 'rmc 10/5/2014 14:16'!
setJournal: aAcadAttribute
	"sets this paper's journal"

	journal := aAcadAttribute.! !

!AcadPaper methodsFor: 'initialize' stamp: 'rmc 10/5/2014 14:03'!
withHtlmPaper: aHtmlPaper
	"this method will the htmlPaper to the filter several times, each time trying to find
	 a specifc attribute, and then, it adds the attribute to the grid. Different regex will
	 be passed as parameter for each attribute it tries to find"
	
	^ self notYetImplemented.! !

GODData subclass: #AcadResearcher
	instanceVariableNames: 'job papers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODAcademics'!

!AcadResearcher methodsFor: 'accessing' stamp: 'rmc 10/5/2014 14:18'!
getJob
	"returns the job of the researcher"

	^job getValue.! !

!AcadResearcher methodsFor: 'accessing' stamp: 'rmc 10/5/2014 14:19'!
getPapers
	"returns a collection of papers"

	^papers.! !

!AcadResearcher methodsFor: 'initialize' stamp: 'rmc 10/5/2014 14:23'!
withPage: aHtmlPage
	"this method creates a researcher. It first tries to find its attributes using the filter,
	 then it asks for the filter for a collection of htmlPapers, and for each of these, it
	 creates a new AcadPaper and add it to the grid"

	^self notYetImplemented.! !
